## libvigraimpex 1.8.0+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

##################################################
#
#     basic initializations
#
##################################################

PROJECT(vigra)

# read the current version from configVersion.hxx
file(READ ${vigra_SOURCE_DIR}/include/vigra/configVersion.hxx VIGRA_VERSION_FILE)
string(REGEX MATCH "VIGRA_VERSION_MAJOR[ \t\n]+[^ \t\n]+" VIGRA_VERSION_MAJOR ${VIGRA_VERSION_FILE})
string(REGEX REPLACE "VIGRA_VERSION_MAJOR[ \t\n]" "" VIGRA_VERSION_MAJOR ${VIGRA_VERSION_MAJOR})
string(REGEX MATCH "VIGRA_VERSION_MINOR[ \t\n]+[^ \t\n]+" VIGRA_VERSION_MINOR ${VIGRA_VERSION_FILE})
string(REGEX REPLACE "VIGRA_VERSION_MINOR[ \t\n]" "" VIGRA_VERSION_MINOR ${VIGRA_VERSION_MINOR})
string(REGEX MATCH "VIGRA_VERSION_PATCH[ \t\n]+[^ \t\n]+" VIGRA_VERSION_PATCH ${VIGRA_VERSION_FILE})
string(REGEX REPLACE "VIGRA_VERSION_PATCH[ \t\n]" "" VIGRA_VERSION_PATCH ${VIGRA_VERSION_PATCH})

SET(vigra_version_short ${VIGRA_VERSION_MAJOR}.${VIGRA_VERSION_MINOR})
SET(vigra_version ${VIGRA_VERSION_MAJOR}.${VIGRA_VERSION_MINOR}.${VIGRA_VERSION_PATCH})
message(STATUS "Configuring VIGRA version ${vigra_version}")

SET(CMAKE_MODULE_PATH  ${CMAKE_MODULE_PATH}  ${vigra_SOURCE_DIR}/config)

include(VigraSetDefaults)
include(VigraCMakeUtils)

INCLUDE_DIRECTORIES(${vigra_SOURCE_DIR}/include)

IF(VIGRA_STATIC_LIB)
    SET(LIBTYPE STATIC)
    ADD_DEFINITIONS(-DVIGRA_STATIC_LIB)
ELSE(VIGRA_STATIC_LIB)
    SET(LIBTYPE SHARED)
ENDIF(VIGRA_STATIC_LIB)

IF (MSVC)
    ADD_DEFINITIONS(-D_CRT_SECURE_NO_DEPRECATE -D_SCL_SECURE_NO_DEPRECATE)
ENDIF ()

##################################################
#
#     search for dependencies
#
##################################################

INCLUDE(VigraFindPackage)
VIGRA_FIND_PACKAGE(TIFF NAMES libtiff)
VIGRA_FIND_PACKAGE(JPEG NAMES libjpeg)
VIGRA_FIND_PACKAGE(PNG)
VIGRA_FIND_PACKAGE(OpenEXR)
VIGRA_FIND_PACKAGE(FFTW3 NAMES libfftw3-3)
VIGRA_FIND_PACKAGE(FFTW3F NAMES libfftw3f-3)
IF(WITH_HDF5)
    VIGRA_FIND_PACKAGE(HDF5)
ENDIF()

SET(DOXYGEN_SKIP_DOT TRUE)
FIND_PACKAGE(Doxygen)
FIND_PACKAGE(PythonInterp)

IF(WITH_VIGRANUMPY)
    FIND_PACKAGE( VIGRANUMPY_DEPENDENCIES )
ENDIF()

IF(WITH_VALGRIND)
    FIND_PROGRAM(VALGRIND_EXECUTABLE valgrind)
ENDIF()

##################################################
#
#     setup testing environment
#
##################################################

ADD_CUSTOM_TARGET(check)
ADD_CUSTOM_TARGET(ctest COMMAND ${CMAKE_CTEST_COMMAND})

ADD_CUSTOM_TARGET(check_cpp)
ADD_DEPENDENCIES(check check_cpp)


OPTION(CREATE_CTEST_TARGETS "Create special targets for CTest" OFF)
IF(CREATE_CTEST_TARGETS)
  INCLUDE(CTest)
ENDIF()

IF(WITH_VIGRANUMPY)
    ADD_CUSTOM_TARGET(check_python)
    ADD_DEPENDENCIES(check check_python)
ENDIF()

ENABLE_TESTING()

##################################################
#
#     setup documentation generator
#
##################################################

ADD_CUSTOM_TARGET(doc)

##################################################
#
#     setup private experimentation target
#
##################################################

ADD_CUSTOM_TARGET(experiments)

##################################################
#
#     subdirectories
#
##################################################

ADD_SUBDIRECTORY(src)
ADD_SUBDIRECTORY(test)
ADD_SUBDIRECTORY(docsrc)

IF(WITH_VIGRANUMPY)
    ADD_SUBDIRECTORY(vigranumpy)
ENDIF()

IF(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/private/CMakeLists.txt)
    ADD_SUBDIRECTORY(private EXCLUDE_FROM_ALL)
ENDIF()


##################################################
#
#     global installation commands
#
##################################################

INSTALL(DIRECTORY ${PROJECT_SOURCE_DIR}/include/vigra
        DESTINATION include)

##################################################
#
#     enable CPack package generation
#
##################################################
INCLUDE(CPackConfig)

##################################################
#
#     add target vigra-$version-src.tar.gz
#
##################################################

find_program(GIT_EXECUTABLE 
              NAMES git git.exe git.cmd
              HINTS $ENV{ProgramFiles}/Git/bin
              DOC "git command line client")

CONFIGURE_FILE(${PROJECT_SOURCE_DIR}/config/package-src.cmake.in
                ${PROJECT_BINARY_DIR}/package-src.cmake
                @ONLY IMMEDIATE)

add_custom_target(PACKAGE_SRC_TAR
                   COMMAND ${CMAKE_COMMAND} -P package-src.cmake
                   WORKING_DIRECTORY "${PROJECT_BINARY_DIR}"
                   COMMENT "Creating ${PROJECT_BINARY_DIR}/vigra-${vigra_version}-src.tar.gz")        

ADD_DEPENDENCIES(PACKAGE_SRC_TAR check)
ADD_DEPENDENCIES(PACKAGE_SRC_TAR doc_cpp)
IF(WITH_VIGRANUMPY)
    ADD_DEPENDENCIES(PACKAGE_SRC_TAR doc_python)
ENDIF()

##################################################
#
#  enable other non-CMake projects to find Vigra
#
##################################################

IF(NOT WIN32)
# vigra-config script for (non-CMake-based) third party packages
CONFIGURE_FILE(${PROJECT_SOURCE_DIR}/config/vigra-config.in
        ${PROJECT_BINARY_DIR}/bin/vigra-config
        @ONLY IMMEDIATE)
INSTALL(FILES ${PROJECT_BINARY_DIR}/bin/vigra-config
        DESTINATION bin
        PERMISSIONS
            OWNER_READ OWNER_WRITE OWNER_EXECUTE
            GROUP_READ GROUP_EXECUTE
            WORLD_READ WORLD_EXECUTE)
ENDIF(NOT WIN32)

##################################################
#
#     enable other CMake projects to find Vigra
#
##################################################

# config file for CMake FIND_PACKAGE command (for using the build tree)
CONFIGURE_FILE(${PROJECT_SOURCE_DIR}/config/VigraConfigBuild.cmake.in
        ${PROJECT_BINARY_DIR}/VigraConfig.cmake
        @ONLY IMMEDIATE)
CONFIGURE_FILE(${PROJECT_SOURCE_DIR}/config/VigraConfigVersion.cmake.in
        ${PROJECT_BINARY_DIR}/VigraConfigVersion.cmake
        @ONLY IMMEDIATE)

# config file for CMake FIND_PACKAGE command
CONFIGURE_FILE(${PROJECT_SOURCE_DIR}/config/VigraConfig.cmake.in
        ${PROJECT_BINARY_DIR}/lib/vigra/CMake/VigraConfig.cmake
        @ONLY IMMEDIATE)
CONFIGURE_FILE(${PROJECT_SOURCE_DIR}/config/VigraConfigVersion.cmake.in
        ${PROJECT_BINARY_DIR}/lib/vigra/CMake/VigraConfigVersion.cmake
        @ONLY IMMEDIATE)

# export targets:
INSTALL(EXPORT vigra-targets
        DESTINATION lib${LIBDIR_SUFFIX}/vigra)
INSTALL(FILES ${PROJECT_BINARY_DIR}/lib/vigra/CMake/VigraConfig.cmake
            ${PROJECT_BINARY_DIR}/lib/vigra/CMake/VigraConfigVersion.cmake
        DESTINATION lib${LIBDIR_SUFFIX}/vigra)
EXPORT(TARGETS vigraimpex FILE vigra-targets.cmake)

##################################################
#
#     status output
#
##################################################

MESSAGE( STATUS "---------------------------------------------------------" )
MESSAGE( STATUS "VIGRA configuration information:" )
MESSAGE( STATUS "---------------------------------------------------------" )

IF(TIFF_FOUND)
    MESSAGE( STATUS "  Using TIFF libraries: ${TIFF_LIBRARIES}" )
ELSE()
    MESSAGE( STATUS "  TIFF libraries not found (TIFF support disabled)" )
ENDIF()

IF(JPEG_FOUND)
    MESSAGE( STATUS "  Using JPEG libraries: ${JPEG_LIBRARIES}" )
ELSE()
    MESSAGE( STATUS "  JPEG libraries not found (JPEG support disabled)" )
ENDIF()

IF(PNG_FOUND)
    MESSAGE( STATUS "  Using PNG  libraries: ${PNG_LIBRARIES}" )
ELSE()
    MESSAGE( STATUS "  PNG libraries not found (PNG support disabled)" )
ENDIF()

IF(OPENEXR_FOUND)
    MESSAGE( STATUS "  Using OpenEXR  libraries: ${OPENEXR_LIBRARIES}" )
ELSE()
    MESSAGE( STATUS "  OpenEXR libraries not found (OpenEXR support disabled)" )
ENDIF()

IF(FFTW3_FOUND)
    MESSAGE( STATUS "  Using FFTW libraries: ${FFTW3_LIBRARIES}" )
ELSE()
    MESSAGE( STATUS "  FFTW libraries not found (FFTW support disabled)" )
ENDIF()

IF(HDF5_FOUND)
    MESSAGE( STATUS "  Using HDF5 libraries: ${HDF5_LIBRARIES}" )
ELSE()
    MESSAGE( STATUS "  HDF5 libraries not found (HDF5 support disabled)" )
ENDIF()

IF(WITH_VIGRANUMPY)
    IF(VIGRANUMPY_DEPENDENCIES_FOUND)
        MESSAGE( STATUS "  Using Python libraries: ${VIGRANUMPY_LIBRARIES}" )
    ELSE()
        MESSAGE( STATUS "  Vigranumpy dependencies not found (vigranumpy disabled)" )
    ENDIF()
ENDIF()

MESSAGE( STATUS "---------------------------------------------------------" )

IF(VIGRA_STATIC_LIB)
    MESSAGE( STATUS "  building static lib" )
ELSE()
    MESSAGE( STATUS "  building shared lib" )
ENDIF()

MESSAGE( STATUS "  binaries will be generated in: ${CMAKE_CURRENT_BINARY_DIR}")
IF(DOXYGEN_FOUND AND PYTHONINTERP_FOUND)
    MESSAGE( STATUS "  manuals will be generated in: ${DOCDIR}")
ENDIF()

MESSAGE( STATUS "---------------------------------------------------------" )

MESSAGE( STATUS "  includes will be installed at: ${CMAKE_INSTALL_PREFIX}/include")
MESSAGE( STATUS "  libraries will be installed at: ${CMAKE_INSTALL_PREFIX}/lib${LIBDIR_SUFFIX}")

IF (MSVC)
  MESSAGE( STATUS "  binaries and DLLs will be installed at: ${CMAKE_INSTALL_PREFIX}/bin")
else()
  MESSAGE( STATUS "  binaries will be installed at: ${CMAKE_INSTALL_PREFIX}/bin")
endif()

IF(DOXYGEN_FOUND AND PYTHONINTERP_FOUND)
  MESSAGE( STATUS "  vigra manuals will be installed at: "
    "${CMAKE_INSTALL_PREFIX}/${DOCINSTALL}/vigra/index.html")
ELSE()
  MESSAGE( STATUS "  vigra manuals cannot be generated (Doxygen or Python not found)")
ENDIF()

IF(WITH_VIGRANUMPY AND VIGRANUMPY_DEPENDENCIES_FOUND)
  MESSAGE( STATUS "  vigranumpy will be installed at ${CMAKE_INSTALL_PREFIX}/${VIGRANUMPY_INSTALL_DIR}" )
  IF(PYTHON_SPHINX)
    MESSAGE( STATUS "  vigranumpy manuals will be installed at: "
      "${CMAKE_INSTALL_PREFIX}/${DOCINSTALL}/vigranumpy/html/index.html")
  ELSE(PYTHON_SPHINX)
    MESSAGE( STATUS "  vigranumpy manuals cannot be generated "
      "(Sphinx missing)")
  ENDIF(PYTHON_SPHINX)
ELSE()
  MESSAGE( STATUS "  vigranumpy will NOT be installed" )
ENDIF()

IF(NOT TIFF_FOUND OR NOT JPEG_FOUND OR NOT PNG_FOUND OR NOT FFTW3_FOUND OR
   NOT HDF5_FOUND OR NOT VIGRANUMPY_DEPENDENCIES_FOUND)
  MESSAGE( STATUS "" )
  MESSAGE( STATUS "Consider setting DEPENDENCY_SEARCH_PREFIX to find missing libraries" )
ENDIF()

MESSAGE( STATUS "---------------------------------------------------------" )

=== test/CMakeLists.txt ===
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/include)

INCLUDE(VigraAddTest)

ADD_SUBDIRECTORY(error)
ADD_SUBDIRECTORY(impex)
ADD_SUBDIRECTORY(utilities)
ADD_SUBDIRECTORY(pixeltypes)
ADD_SUBDIRECTORY(colorspaces)
ADD_SUBDIRECTORY(classifier)
ADD_SUBDIRECTORY(imgproc)
ADD_SUBDIRECTORY(functorexpression)
ADD_SUBDIRECTORY(convolution)
ADD_SUBDIRECTORY(morphology)
ADD_SUBDIRECTORY(fourier)
ADD_SUBDIRECTORY(math)
ADD_SUBDIRECTORY(optimization)
ADD_SUBDIRECTORY(tensorimaging)
ADD_SUBDIRECTORY(simpleanalysis)
ADD_SUBDIRECTORY(image)
ADD_SUBDIRECTORY(multiarray)
ADD_SUBDIRECTORY(multiconvolution)
ADD_SUBDIRECTORY(voxelneighborhood)
ADD_SUBDIRECTORY(volumelabeling)
ADD_SUBDIRECTORY(watersheds3d)
ADD_SUBDIRECTORY(multidistance)
ADD_SUBDIRECTORY(multimorphology)
ADD_SUBDIRECTORY(seededRegionGrowing3d)
ADD_SUBDIRECTORY(sampler)
ADD_SUBDIRECTORY(hdf5impex)
ADD_SUBDIRECTORY(sifImport)
ADD_SUBDIRECTORY(features)
ADD_SUBDIRECTORY(unsupervised)

=== src/impex/CMakeLists.txt ===
IF(JPEG_FOUND)
  ADD_DEFINITIONS(-DHasJPEG)
  INCLUDE_DIRECTORIES(${JPEG_INCLUDE_DIR})
ENDIF(JPEG_FOUND)

IF(PNG_FOUND)
  ADD_DEFINITIONS(-DHasPNG)
  INCLUDE_DIRECTORIES(${PNG_INCLUDE_DIR})
ENDIF(PNG_FOUND)

IF(TIFF_FOUND)
  ADD_DEFINITIONS(-DHasTIFF)
  INCLUDE_DIRECTORIES(${TIFF_INCLUDE_DIR})
ENDIF(TIFF_FOUND)

IF(OPENEXR_FOUND)
  ADD_DEFINITIONS(-DHasEXR)
  INCLUDE_DIRECTORIES(${OPENEXR_INCLUDE_DIR})
ENDIF(OPENEXR_FOUND)

IF(HDF5_FOUND)
  ADD_DEFINITIONS(-DHasHDF5 ${HDF5_CPPFLAGS})
  INCLUDE_DIRECTORIES(${HDF5_INCLUDE_DIR})
ENDIF(HDF5_FOUND)

IF (MSVC OR MINGW)
    IF(NOT VIGRA_STATIC_LIB)
        ADD_DEFINITIONS(-DVIGRA_DLL)
    ENDIF()
ELSEIF(CMAKE_COMPILER_IS_GNUCXX)
    IF(VIGRA_STATIC_LIB)
        ADD_DEFINITIONS(-fPIC -DPIC)
    ENDIF()
ENDIF ()

ADD_LIBRARY(vigraimpex ${LIBTYPE}
    bmp.cxx
    byteorder.cxx
    codecmanager.cxx
    exr.cxx
    gif.cxx
    hdr.cxx
    hdf5impex.cxx
    hdf5_rf_impex.cxx
    iccjpeg.c
    imageinfo.cxx
    jpeg.cxx
    png.cxx
    pnm.cxx
    rgbe.c
    sifImport.cxx
    sun.cxx
    tiff.cxx
    viff.cxx
    void_vector.cxx)

STRING(REGEX REPLACE "\\." "" LIBRARY_VERSION_STRING ${vigra_version})
SET_TARGET_PROPERTIES(vigraimpex PROPERTIES VERSION 4.${LIBRARY_VERSION_STRING} SOVERSION 4)

IF(JPEG_FOUND)
  TARGET_LINK_LIBRARIES(vigraimpex ${JPEG_LIBRARIES})
ENDIF(JPEG_FOUND)

IF(PNG_FOUND)
  TARGET_LINK_LIBRARIES(vigraimpex ${PNG_LIBRARIES})
ENDIF(PNG_FOUND)

IF(TIFF_FOUND)
  TARGET_LINK_LIBRARIES(vigraimpex ${TIFF_LIBRARIES})
ENDIF(TIFF_FOUND)

IF(OPENEXR_FOUND)
  TARGET_LINK_LIBRARIES(vigraimpex ${OPENEXR_LIBRARIES})
ENDIF(OPENEXR_FOUND)

IF(HDF5_FOUND)
  TARGET_LINK_LIBRARIES(vigraimpex ${HDF5_LIBRARIES})
ENDIF(HDF5_FOUND)

INSTALL(TARGETS vigraimpex
        EXPORT vigra-targets
        RUNTIME DESTINATION bin 
        LIBRARY DESTINATION lib${LIBDIR_SUFFIX} 
        ARCHIVE DESTINATION lib${LIBDIR_SUFFIX})

=== test/impex/CMakeLists.txt ===
IF(JPEG_FOUND)
  ADD_DEFINITIONS(-DHasJPEG)
ENDIF(JPEG_FOUND)

IF(PNG_FOUND)
  ADD_DEFINITIONS(-DHasPNG)
ENDIF(PNG_FOUND)

IF(TIFF_FOUND)
  ADD_DEFINITIONS(-DHasTIFF)
ENDIF(TIFF_FOUND)

IF(OPENEXR_FOUND)
  ADD_DEFINITIONS(-DHasEXR)
ENDIF(OPENEXR_FOUND)

VIGRA_ADD_TEST(test_impex test.cxx LIBRARIES vigraimpex)

VIGRA_COPY_TEST_DATA(lenna.xv lenna_gifref.xv lennafloat.xv lennafloatrgb.xv lennargb.xv no-image.txt lenna_0.tif lenna_1.tif lenna_2.tif)

=== vigranumpy/src/core/CMakeLists.txt ===

# note special treatment of target vigranumpy_core: 
# module name is automatically changed into vigranumpycore
VIGRA_ADD_NUMPY_MODULE(core 
  SOURCES 
    vigranumpycore.cxx
    converters.cxx
    axistags.cxx
  VIGRANUMPY)

VIGRA_ADD_NUMPY_MODULE(impex 
  SOURCES
    impex.cxx
  LIBRARIES   
    ${VIGRANUMPY_IMPEX_LIBRARIES}
  VIGRANUMPY)   
     
VIGRA_ADD_NUMPY_MODULE(sampling 
  SOURCES
    sampling.cxx
  VIGRANUMPY)
   
VIGRA_ADD_NUMPY_MODULE(filters SOURCES
    kernel.cxx
    convolution.cxx
    filters.cxx
    tensors.cxx
    morphology.cxx
  VIGRANUMPY)
   
VIGRA_ADD_NUMPY_MODULE(analysis SOURCES
    segmentation.cxx
    edgedetection.cxx
    interestpoints.cxx
  VIGRANUMPY)
   
VIGRA_ADD_NUMPY_MODULE(learning SOURCES
    random_forest_old.cxx
    random_forest.cxx
    learning.cxx
  LIBRARIES   
    ${VIGRANUMPY_IMPEX_LIBRARIES}
  VIGRANUMPY)
   
VIGRA_ADD_NUMPY_MODULE(colors SOURCES
    colors.cxx
  VIGRANUMPY)
   
VIGRA_ADD_NUMPY_MODULE(noise SOURCES
    noise.cxx
  VIGRANUMPY)
   
VIGRA_ADD_NUMPY_MODULE(geometry SOURCES
    geometry.cxx
  VIGRANUMPY)

=== debian/changelog ===
libvigraimpex (1.8.0+dfsg-0ubuntu2) quantal; urgency=low

  * New upstream version.
    - Fixes build failure; tested that the two rdeps in thea archive do
      build and work. LP: #1056759.
  * Update patches for new upstream release.
  * Bump libvigraimpex soname to 4, update symbols file.
  * Fix (new?) GCC 4.7 build failures.
  * Fix build failure with doxygen 1.8.x.
  * debian/rules: Remove -mieee for sh4, it's now the default.
  * Build with -ffloat-store on i386, to let the testsuite pass.
  * Don't stop running the testsuite on the first error.
  * On powerpc, run the tests, but ignore the test results.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 25 Sep 2012 16:18:23 +0200

libvigraimpex (1.7.1+dfsg1-3ubuntu2) quantal; urgency=low

  * debian/control:
    - Build-Depend on libtiff5-dev

 -- Michael Terry <mterry@ubuntu.com>  Mon, 09 Jul 2012 17:21:58 -0400

libvigraimpex (1.7.1+dfsg1-3ubuntu1) quantal; urgency=low

  * Merge with Debian testing.  Remaining Ubuntu changes:
    - Remove build dependency on libhdf5-serial-dev (universe).  LP: #635891.
    - debian/patches/no-hdf5.diff: Comment out additional methods
      requiring HDF5.
    - debian/libvigraimpex3.symbols: Mark additional HDF5 related symbols
      as optional since these won't appear in the library.
    - Build using dh_python2
    - debian/patches/debian-changes-1.7.1+dfsg1-2ubuntu1: refactor
      include/vigra/noise_normalization.hxx

  * Dropped changes:
    - 1.7.1+dfsg1-2ubuntu1 upload introduced an auto-generated patch with
    merge conflicts and changes to include/vigra/numpy_array.hxx, which
    got reverted in the 1.7.1+dfsg1-2ubuntu2 upload by ending
    sizeof_ldbl_not_sizeof_dbl.diff to fix FTBFS. I have dropped merge
    conflicts & changes to numpy_array.hxx in both patches. Remaining
    change is documented above.

 -- Dmitrijs Ledkovs <dmitrij.ledkov@ubuntu.com>  Thu, 14 Jun 2012 20:58:40 +0100

libvigraimpex (1.7.1+dfsg1-2ubuntu4) precise; urgency=low

  * No change rebuild to pick up a numpy ABI

 -- Micah Gersten <micahg@ubuntu.com>  Sun, 19 Feb 2012 15:51:36 -0600

libvigraimpex (1.7.1+dfsg1-2ubuntu3) precise; urgency=low

  * Build using dh_python2

 -- Matthias Klose <doko@ubuntu.com>  Sat, 17 Dec 2011 12:59:21 +0000

libvigraimpex (1.7.1+dfsg1-2ubuntu2) precise; urgency=low

  * Add sizeof_ldbl_not_sizeof_dbl.diff (backport fix from upstream
    refactored include/vigra/numpy_array_traits.hxx). Fixes FTBFS on
    armel.

 -- Daniel T Chen <crimsun@ubuntu.com>  Tue, 08 Nov 2011 19:31:51 -0500

libvigraimpex (1.7.1+dfsg1-2ubuntu1) precise; urgency=low

  * Merge with Debian testing.  Remaining Ubuntu changes:
    - Remove build dependency on libhdf5-serial-dev (universe).  LP: #635891.
    - debian/patches/no-hdf5.diff: Comment out additional methods
      requiring HDF5.
    - debian/libvigraimpex3.symbols: Mark additional HDF5 related symbols
      as optional since these won't appear in the library.

 -- Barry Warsaw <barry@ubuntu.com>  Thu, 20 Oct 2011 09:30:45 -0400

libvigraimpex (1.7.0+dfsg-7ubuntu7) oneiric; urgency=low

  * Backport from Debian (Jakub Wilk, LP: #829462):
    - Update docsrc-doxygen-1.7.diff to deal with the latest Doxygen.

 -- Colin Watson <cjwatson@ubuntu.com>  Thu, 25 Aug 2011 11:48:11 +0100

=== debian/control ===
Source: libvigraimpex
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends: dpkg-dev (>= 1.15.3~), debhelper (>= 7.0.50~),
  cmake,
  libfftw3-dev, libpng-dev, libjpeg-dev, libtiff5-dev,
  python-all-dev, python-numpy, libboost-python-dev, python-nose
Build-Depends-Indep:
  python, python-sphinx, doxygen, texlive-latex-base, ghostscript
Build-Conflicts: autoconf2.13
X-Python-Version: >= 2.5
Standards-Version: 3.9.3
Homepage: http://hci.iwr.uni-heidelberg.de/vigra/

Package: libvigraimpex-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, ${python:Depends},
  libvigraimpex4 (= ${binary:Version}),
  libfftw3-dev, libpng12-dev, libjpeg-dev, libtiff5-dev
Suggests: libvigraimpex-doc
Description: development files for the C++ computer vision library
 Vision with Generic Algorithms (VIGRA) is a computer vision library
 that puts its main emphasis on flexible algorithms, because
 algorithms represent the principle know-how of this field. The
 library was consequently built using generic programming as
 introduced by Stepanov and Musser and exemplified in the C++ Standard
 Template Library. By writing a few adapters (image iterators and
 accessors) you can use VIGRA's algorithms on top of your data
 structures, within your environment. 
 . 
 This package contains the header and development files needed to
 build programs and packages using VIGRA.

Package: libvigraimpex4
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C++ computer vision library
 Vision with Generic Algorithms (VIGRA) is a computer vision library 
 that puts its main emphasis on flexible algorithms, because
 algorithms represent the principle know-how of this field. The
 library was consequently built using generic programming as
 introduced by Stepanov and Musser and exemplified in the C++ Standard
 Template Library. By writing a few adapters (image iterators and
 accessors) you can use VIGRA's algorithms on top of your data
 structures, within your environment. 

Package: libvigraimpex-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Suggests: libvigraimpex-dev, python-vigra-doc
Description: Documentation for the C++ computer vision library
 Vision with Generic Algorithms (VIGRA) is a computer vision library
 that puts its main emphasis on flexible algorithms, because
 algorithms represent the principle know-how of this field. The
 library was consequently built using generic programming as
 introduced by Stepanov and Musser and exemplified in the C++ Standard
 Template Library. By writing a few adapters (image iterators and
 accessors) you can use VIGRA's algorithms on top of your data
 structures, within your environment. 
 . 
 This package contains documentation for the VIGRA library.

Package: python-vigra
Section: python
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, ${python:Depends}
Recommends: python-qt4
Suggests: python-vigra-doc, python-h5py
Description: Python bindings for the C++ computer vision library
 Vision with Generic Algorithms (VIGRA) is a computer vision library
 that puts its main emphasis on flexible algorithms, because
 algorithms represent the principle know-how of this field. The
 library was consequently built using generic programming as
 introduced by Stepanov and Musser and exemplified in the C++ Standard
 Template Library. By writing a few adapters (image iterators and
 accessors) you can use VIGRA's algorithms on top of your data
 structures, within your environment.
 .
 This package exports the functionality of the VIGRA library to Python.

Package: python-vigra-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}, ${sphinxdoc:Depends}
Suggests: python-vigra, libvigraimpex-doc
Description: Documentation for Python bindings for the C++ computer vision library
 Vision with Generic Algorithms (VIGRA) is a computer vision library
 that puts its main emphasis on flexible algorithms, because
 algorithms represent the principle know-how of this field. The
 library was consequently built using generic programming as
 introduced by Stepanov and Musser and exemplified in the C++ Standard
 Template Library. By writing a few adapters (image iterators and
 accessors) you can use VIGRA's algorithms on top of your data
 structures, within your environment.
 .
 This package contains documentation for Python bindings for the VIGRA library.

=== debian/rules ===
#!/usr/bin/make -f

CFLAGS := $(shell dpkg-buildflags --get CFLAGS; dpkg-buildflags --get CPPFLAGS)
CXXFLAGS := $(shell dpkg-buildflags --get CXXFLAGS)
LDFLAGS := $(shell dpkg-buildflags --get LDFLAGS) -Wl,--as-needed

# These don't need to be exported and if they are we'll get the flags
# duplicated in the command line.
unexport CFLAGS
unexport CXXFLAGS
unexport LDFLAGS

ifeq ($(DEB_HOST_ARCH_CPU),i386)
  CFLAGS += -ffloat-store
  CXXFLAGS += -ffloat-store
endif

space = $() $()
here = $(dir $(firstword $(MAKEFILE_LIST)))/..
current_version = $(shell cd $(here) && dpkg-parsechangelog | sed -n -r -e "/Version: (.*)/ { s//\1/p; q; }")
upstream_version = $(firstword $(subst -,$(space),$(current_version)))

cmake_options = \
    -DCMAKE_INSTALL_PREFIX=/usr \
    -DCMAKE_VERBOSE_MAKEFILE=ON \
    -DCMAKE_C_FLAGS_RELEASE="$(CFLAGS)" \
    -DCMAKE_CXX_FLAGS_RELEASE="$(CXXFLAGS)" \
    -DCMAKE_SHARED_LINKER_FLAGS_RELEASE="$(LDFLAGS)"
cmake_python_options = \
    -DPYTHON_EXECUTABLE=/usr/bin/python$(1) \
    -DPYTHON_INCLUDE_DIR=/usr/include/python$(1)/ \
    -DPYTHON_LIBRARY=/usr/lib/libpython$(1).so \
    -DBoost_PYTHON_LIBRARY_RELEASE=/usr/lib/libboost_python-py$$(echo $(1) | tr -d .).so

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	njobs_requested := $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
ifeq ($(wildcard /build/buildd-*/),)
	njobs := $(njobs_requested)
else
	# On buildds, artificially limit paralellism in order not to run out of RAM.
	mem_total := $(shell grep MemTotal /proc/meminfo | tr -s ' ' | cut -d' ' -f2)
	njobs_max := $(patsubst 0,1,$(shell echo $$(( $(mem_total) / 500000 ))))
	njobs := $(shell echo $$(( $(njobs_requested) > $(njobs_max) ? $(njobs_max) : $(njobs_requested) )))
endif
	parallel := -j$(or $(njobs),1)
endif

# build and build-* targets
# =========================

.PHONY: build build-arch build-indep

build: build-arch build-indep

build-indep:
	# Nothing to do in build-indep, "thanks" to bug #374029.

build-arch:
	dh_testdir
	$(info INFO: number of parallel processes:)
	$(info - requested: $(or $(njobs_requested),none))
	$(info - maximum: $(or $(njobs_max),none))
	$(info - actual: $(or $(njobs),1))
	$(MAKE) -f debian/rules \
		obj/CMakeCache.txt \
		$(patsubst %,obj.%/CMakeCache.txt,$(shell pyversions -r))
	$(MAKE) -f debian/rules \
		doc/changelog \
		obj/build-stamp \
		$(patsubst %,obj.%/build-stamp,$(shell pyversions -r))
ifeq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
  ifneq (,$(filter $(DEB_HOST_ARCH_CPU),powerpc))
	: # run the tests, but ignore test results
	-$(MAKE) -k -f debian/rules \
		obj/test-stamp \
		$(patsubst %,obj.%/test-stamp,$(shell pyversions -r))
  else
	$(MAKE) -k -f debian/rules \
		obj/test-stamp \
		$(patsubst %,obj.%/test-stamp,$(shell pyversions -r))
  endif
endif

obj/CMakeCache.txt:
	mkdir -p $(dir $(@))
	cd $(dir $(@)) && cmake .. $(cmake_options) \
		-DPYTHON_EXECUTABLE=/usr/bin/python \
		-DWITH_VIGRANUMPY=0

obj.python%/CMakeCache.txt:
	mkdir -p $(dir $(@))
	cd $(dir $(@)) && \
		CXXFLAGS=-fno-strict-aliasing cmake .. $(cmake_options) $(call cmake_python_options,$(*))
	if ! grep VIGRANUMPY_DEPENDENCIES $(@) > /dev/null; then \
		echo "Error: Numpy for Python $* not found" >&2; \
		rm -f $(@); \
		exit 1; \
	fi
	# We don't want to link with libpythonX.Y.
	# We don't want SONAMES (except vigranumpycore.so)
	find $(dir $(@))/vigranumpy/ -name 'link.txt' -exec sed -i \
		-e 's/ -lpython[0-9.]\+ / /g' \
		-e '/-Wl,-soname,vigranumpycore/b' \
		-e 's/ -Wl,-soname,[^ ]\+ / /' \
		{} +

obj/build-stamp: obj/CMakeCache.txt
	$(MAKE) $(parallel) -C $(dir $(@))
	chmod a-x vigranumpy/test/*.py # nosetest would skip executable *.py
	touch $(@)

obj.python%/build-stamp: obj.python%/CMakeCache.txt obj/build-stamp
	cd obj && find . -name '*.o' -o -name '*.so' -o -name '*.so.*' | xargs cp -v --preserve=links --parents -t ../$(dir $(@))
	$(MAKE) $(parallel) -C $(dir $(@))
	touch $(@)

obj/test-stamp: obj/build-stamp
	$(MAKE) check -C $(dir $(@))
	touch $(@)

obj.python%/test-stamp:: obj.python%/build-stamp
	$(MAKE) vigranumpytest -C $(dir $(@))
	touch $(@)

doc/changelog: docsrc/credits_changelog.dxx
	sh debian/convert-changelog.sh < $(<) > $(@)

# binary and binary-* targets
# ===========================

.PHONY: binary binary-arch binary-indep

binary: binary-arch binary-indep

binary-arch: build-arch
	dh_testdir
	dh_testroot
	$(MAKE) -f debian/rules \
		obj/install-stamp \
		$(patsubst %,obj.%/install-stamp,$(shell pyversions -r))
	dh_install -a
	dh_installdocs -a
	dh_installchangelogs -a doc/changelog
	dh_installexamples -a
	find -path './debian/*/usr/share/doc/*/examples/*' -exec chmod a-x '{}' +
	dh_installman -a
	dh_python2 -a
	dh_link -a
	dh_compress -a
	dh_fixperms -a
	dh_strip -a
	dh_makeshlibs
	sed -i -e 's/= PRIVATE/= $(current_version)/' debian/*/DEBIAN/symbols
	dh_shlibdeps
	# See <http://lists.debian.org/debian-python/2010/07/msg00042.html>:
	$(or $(wildcard /usr/bin/dh_numpy),debian/dh_numpy) -p python-vigra
	dh_installdeb -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

.PHONY: binary-indep
binary-indep: build-indep
	dh_testdir
	dh_testroot
	$(MAKE) -f debian/rules \
		doc/vigra/build-stamp \
		doc/vigranumpy/build-stamp
	dh_installdocs -i -XLICENSE.txt -Xobjects.inv -Xdoctrees -X.buildinfo -Xbuild-stamp
	cd debian/libvigraimpex-doc/usr/share/doc/libvigraimpex-doc/ && \
		rm -rf html && \
		mv vigra html && \
		rm -f html/jquery.js && \
		sed -r -i \
			-e 's!(<a href=")LICENSE.txt(">)!\1/usr/share/doc/libvigraimpex-doc/copyright\2!g' \
			html/index.html
	cd debian/python-vigra-doc/usr/share/doc/python-vigra-doc/ && \
		rm -rf html && \
		mv vigranumpy html
	dh_installchangelogs -i
	dh_link -i
ifeq "$(wildcard /usr/bin/dh_sphinxdoc)" ""
	echo "sphinxdoc:Depends=libjs-jquery" >> debian/python-vigra-doc.substvars
else
	dh_sphinxdoc -p python-vigra-doc /usr/share/doc/python-vigra-doc/html/
endif
	dh_compress -i -X.js -X_sources
	dh_fixperms -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

%/install-stamp: %/build-stamp
	$(MAKE) -C $(dir $(@)) install DESTDIR=$(CURDIR)/debian/tmp/
	touch $(@)

doc/vigra/build-stamp: obj/build-stamp
	$(MAKE) doc_cpp -C obj/
	touch $(@)

doc/vigranumpy/build-stamp: obj.$(shell pyversions -d)/build-stamp doc/vigra/build-stamp
	ln -sf $(CURDIR)/vigranumpy/docsrc/c_api_replaces.txt obj.$(shell pyversions -d)/vigranumpy/docsrc/
	$(MAKE) doc_python -C obj.$(shell pyversions -d)/
	touch $(@)

# clean target
# ============

.PHONY: clean
clean:
	dh_testdir
	dh_clean
	rm -rf obj*/
	find doc/ -type f -delete

# get-orig-source target
# ======================

.PHONY: get-orig-source
get-orig-source:
	sh $(here)/debian/get-orig-source.sh 1.8.0
	#sh $(here)/debian/get-orig-source.sh $(upstream_version)

.NOTPARALLEL:

# vim:ts=4 sw=4 noet

## libvigraimpex 1.9.0

=== debian/changelog ===
libvigraimpex (1.9.0-0ubuntu2) raring; urgency=low

  * Disable parallel build.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 27 Feb 2013 06:25:02 +0100

libvigraimpex (1.9.0-0ubuntu1) raring; urgency=low

  * New upstream version.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 26 Feb 2013 20:36:20 +0100

libvigraimpex (1.8.0+dfsg-2ubuntu1) raring; urgency=low

  * Merge with Debian; remaining changes:
    - Remove build dependency on libhdf5-serial-dev (universe).
    - debian/patches/no-hdf5.diff: Comment out additional methods
      requiring HDF5.
    - debian/libvigraimpex4.symbols: Mark additional HDF5 related symbols
      as optional since these won't appear in the library.
  * Fix build failure with libpython.so in the multiarch lib location.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 23 Feb 2013 15:01:51 +0100

libvigraimpex (1.8.0+dfsg-2) experimental; urgency=low

  * QA upload.
  * Enable OpenEXR support by adding a build-dependency on libopenexr-dev.
  * Stop using .symbols files, and use 'dh_makeshlibs -V ...' to version the
    shlibs file. This fixes FTBFS with diffferent gcc != 4.7.
    Closes: #691095

 -- Andreas Metzler <ametzler@debian.org>  Sun, 13 Jan 2013 13:10:39 +0100

libvigraimpex (1.8.0+dfsg-1) experimental; urgency=low

  * QA upload.
  * New upstream version.
  * Update patches for new upstream release.
  * Bump libvigraimpex soname to 4, update symbols file.
  * Fix (new?) GCC 4.7 build failures.
  * Fix build failure with doxygen 1.8.x.
  * Build using dh_python2.
  * debian/rules: Remove -mieee for sh4, it's now the default.
  * Build with -ffloat-store on i386, to let the testsuite pass.
  * Don't stop running the testsuite on the first error.
  * On powerpc, run the tests, but ignore the test results.
    It's likely that the build will fail on other archs, after
    inspecting the test results, the outcome of the test should be
    disabled or the precision for some tests be adjusted.

 -- Matthias Klose <doko@debian.org>  Wed, 26 Sep 2012 23:52:37 +0200

=== debian/rules ===
--- 
+++ 
@@ -29,7 +29,7 @@
 cmake_python_options = \
     -DPYTHON_EXECUTABLE=/usr/bin/python$(1) \
     -DPYTHON_INCLUDE_DIR=/usr/include/python$(1)/ \
-    -DPYTHON_LIBRARY=/usr/lib/libpython$(1).so \
+    -DPYTHON_LIBRARY=/usr/lib/$(DEB_HOST_MULTIARCH)/libpython$(1).so \
     -DBoost_PYTHON_LIBRARY_RELEASE=/usr/lib/libboost_python-py$$(echo $(1) | tr -d .).so
 
 ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
@@ -42,6 +42,7 @@
 	njobs_max := $(patsubst 0,1,$(shell echo $$(( $(mem_total) / 500000 ))))
 	njobs := $(shell echo $$(( $(njobs_requested) > $(njobs_max) ? $(njobs_max) : $(njobs_requested) )))
 endif
+	njobs := 1
 	parallel := -j$(or $(njobs),1)
 endif
